// Package specific class for the References lab
// Creates a TwoToneComponent for TwoToneDisplay

// (c) J. Dean Brock, Rebecca F. Bruce, 2004
// Department of Computer Science
// UNC Asheville

package edu.unca.cs.csci201.LabAids ;

class TwoToneComponent extends javax.swing.JComponent {
    
    private java.awt.Insets saveInsets ;
    private int saveWidth ;
    private int saveHeight ;
    private int circleWidth ;
    private int circleHeight ;
    private int topX ;
    private int topY ;
    private int iamX ;
    private int iamY ;
    private int bottomX ;
    private int bottomY ;
    private java.awt.Color  colorTop ;
    private java.awt.Color  colorBottom ;
    String myID ;
          
    public TwoToneComponent(TwoTone tp) {
        saveWidth = saveHeight = -1 ;
        colorTop = tp.getTop() ;
        colorBottom = tp.getBottom() ;
         myID = "I'm " + tp.hashCode() ;
    }

    private void ComputePositions(java.awt.Graphics g) {
        // Get the size of the box
        saveInsets = getInsets() ;
        saveWidth  = getWidth()  ;
        saveHeight = getHeight() ;
            
        // Compute the size of "components" within the box            
        int realWidth  = saveWidth - saveInsets.left - saveInsets.right ;
        int realHeight = saveHeight - saveInsets.top - saveInsets.bottom ;
        circleWidth  = realWidth*7/8 ;
        circleHeight = realHeight*7/18 ;
        topX         = (realWidth - circleWidth)/2 + saveInsets.left ;
        topY         = (realHeight*4/9 - circleHeight)/2 + saveInsets.top ;
        bottomX      = topX ;
        bottomY      = (realHeight*5/9) + topY ;
            
        // Choose and appropriately sized font and
        // coordiantes for "I am ..." string
        int iamFNTsz = Math.min(realWidth/8, realHeight/16) ;
        java.awt.Font iamFNT  = new java.awt.Font("monospaced", 
                                              java.awt.Font.PLAIN, iamFNTsz) ;
        g.setFont(iamFNT) ;
        setFont(iamFNT) ;
        java.awt.FontMetrics iamFM = g.getFontMetrics() ;
        int iamRLw   = iamFM.stringWidth(myID) ;
        int iamRLh   = iamFM.getAscent() ;
        iamX         = (realWidth-iamRLw)/2 + saveInsets.left ;
        iamY         = (realHeight*5/9) + saveInsets.top 
                                        - (realHeight/9 - iamRLh)/2;
    }

    public void paintComponent(java.awt.Graphics g) {
        g = g.create() ;
        if (getWidth() != saveWidth || getHeight() != saveHeight
                                    || !saveInsets.equals(getInsets()))
            ComputePositions(g) ;
        // super.paint(g) ;
        g.setColor(colorTop) ;
        g.fillOval(topX, topY, circleWidth, circleHeight) ;
        g.setColor(java.awt.Color.black) ;
        g.drawString(myID, iamX, iamY) ;
        g.setColor(colorBottom) ;
        g.fillOval(bottomX, bottomY, circleWidth, circleHeight) ;
    }
}
